package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.UserFollowService;
import com.gxwebsoft.shop.entity.UserFollow;
import com.gxwebsoft.shop.param.UserFollowParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 关注记录表控制器
 *
 * @author 科技小王子
 * @since 2022-11-25 19:04:43
 */
@Api(tags = "关注记录表管理")
@RestController
@RequestMapping("/api/shop/user-follow")
public class UserFollowController extends BaseController {
    @Resource
    private UserFollowService userFollowService;

    @PreAuthorize("hasAuthority('shop:userFollow:list')")
    @OperationLog
    @ApiOperation("分页查询关注记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<UserFollow>> page(UserFollowParam param) {
        PageParam<UserFollow, UserFollowParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(userFollowService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(userFollowService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userFollow:list')")
    @OperationLog
    @ApiOperation("查询全部关注记录表")
    @GetMapping()
    public ApiResult<List<UserFollow>> list(UserFollowParam param) {
        PageParam<UserFollow, UserFollowParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(userFollowService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(userFollowService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userFollow:list')")
    @OperationLog
    @ApiOperation("根据id查询关注记录表")
    @GetMapping("/{id}")
    public ApiResult<UserFollow> get(@PathVariable("id") Integer id) {
        return success(userFollowService.getById(id));
        // 使用关联查询
        //return success(userFollowService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:userFollow:save')")
    @OperationLog
    @ApiOperation("添加关注记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody UserFollow userFollow) {
        // 记录当前登录用户id、租户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          userFollow.setUserId(loginUser.getUserId());
        }
        if (userFollowService.save(userFollow)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:userFollow:update')")
    @OperationLog
    @ApiOperation("修改关注记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody UserFollow userFollow) {
        if (userFollowService.updateById(userFollow)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:userFollow:remove')")
    @OperationLog
    @ApiOperation("删除关注记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (userFollowService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:userFollow:save')")
    @OperationLog
    @ApiOperation("批量添加关注记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<UserFollow> list) {
        if (userFollowService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:userFollow:update')")
    @OperationLog
    @ApiOperation("批量修改关注记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<UserFollow> batchParam) {
        if (batchParam.update(userFollowService, "log_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:userFollow:remove')")
    @OperationLog
    @ApiOperation("批量删除关注记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (userFollowService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
